.\" $NetBSD: ksyms.4,v 1.5 2008/04/30 13:10:54 martin Exp $
.\"
.\" Copyright (c) 2003 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd November 12, 2008
.Dt KSYMS 4
.Os
.Sh NAME
.Nm ksyms
.Nd kernel symbol table interface
.Sh SYNOPSIS
.Cd "pseudo-device ksyms"
.Sh DESCRIPTION
The
.Pa /dev/ksyms
character device provides a read-only interface to the current
kernel symbol table.
It can be accessed either as a sequential
file, where it looks like an executable file but with zero-sized
text and data segments, or via
.Xr ioctl 2 .
.Pp
.Pa /dev/ksyms
represents the symbol table at the time when the device is opened,
and may not change until it is closed.
.Pp
The in-kernel symbol manager is designed to be able to handle
any type of symbol table.
However, only
.Xr elf 5
symbol tables are currently dealt with.
.Sh IOCTLS
The
.Xr ioctl 2
command codes below are defined in
.Aq Pa sys/ksyms.h .
.Pp
The (third) argument to the
.Xr ioctl 2
should be a pointer to the type indicated.
.Bl -tag -width indent -offset indent
.It Dv KIOCGSIZE (int)
Returns the total size of the current symbol table.
This should be used when allocating a buffer to read in the
whole symbol table to memory.
.It Dv KIOCGVALUE (struct ksyms_gsymbol)
Returns the value for the given symbol name in a symtab-independent
fashion.
.Bd -literal -offset indent
struct ksyms_gsymbol {
	const char *kg_name;
	unsigned long *kg_value;
};
.Ed
.Pp
The struct element
.Va kg_name
should be set to the name of the requested value, and the address that
.Va kg_value
points to will receive the symbol value.
.It Dv KIOCGSYMBOL (struct ksyms_gsymbol)
Returns the complete symbol for the given symbol name.
.Bd -literal -offset indent
struct ksyms_gsymbol {
	const char *kg_name;
        void *kg_sym;
};
.Ed
.Pp
The struct element
.Va kg_name
should be set to the name of the requested symbol, and the found
symbol will be written to the
.Va kg_sym
address.
It is the callers responsibility to ensure that enough space
for the symbol is allocated.
.El
.Sh FILES
.Bl -tag -width /dev/ksymsX
.It Pa /dev/ksyms
.El
.Sh SEE ALSO
.Xr ioctl 2 ,
.Xr nlist 3 ,
.Xr elf 5
.Sh HISTORY
A
.Nm
device exists in many different operating systems.
This implementation is modelled in function after Solaris
.Nm .
This
.Nm
driver was written by Anders Magnusson for
.Nx .
.Pp
The
.Nm
driver first appeared in
.Nx 2.0 .
